unit CdDoor;
{ TmCDDoor: Marco Caselli's Door Control rel. 1.0
 A stupid component for opening/closing the CD-Rom Door
**********************************************************************
* Feel free to use or give away this software as you see fit.        *
* Please leave the credits in place if you alter the source.         *
*                                                                    *
* This software is delivered to you "as is",                         *
* no guarantees of any kind.                                         *
*                                                                    *
* If you find any bugs, please let me know, I will try to fix them.  *
* If you modify the source code, please send me a copy               *
* Marco Caselli                                                      *
* Web site : http://members.tripod.com/dartclub                      *
* E-mail   : mcaselli@iname.com                                      *
**********************************************************************
*** Sorry for my bad english ...............
 Properties : none !

  Methods:

      Open     : open the CD-Door;
      Close    : close the CD-Door;

*******************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem;

type
  TmCDDoor = class(TComponent)
  private
    DeviceId:word;
    Opened:boolean;
    Flag:longint;

    { Private declarations }
  protected
    constructor create(AOwner:TComponent);override;
    destructor destroy;override;
    { Protected declarations }
  public
    ReturnCode: longint;
    { Public declarations }
  published
    procedure open;
    procedure close;
    { Published declarations }
  end;

procedure Register;

implementation

constructor TmCDDoor.Create(AOwner:TComponent);
var
     OpenParm: tMCI_Open_Parms;
begin
     inherited Create(AOwner);
//   OpenParm.dwCallback := AOwner.handle;
   OpenParm.lpstrDeviceType := 'CDAudio';
   flag:=0;
   Flag := Flag or mci_Open_Type;
   Flag := Flag or mci_Open_Shareable;
   Flag := Flag or Mci_Wait;
   ReturnCode:=mciSendCommand(0, mci_Open, Flag, Longint(@OpenParm));
   DeviceID := OpenParm.wDeviceID;
end;

destructor TmCDDoor.destroy;
var
   GenParm: tMCI_Generic_Parms;
begin
   ReturnCode:=MciSendCommand( DeviceID, mci_Close, Flag, Longint(@GenParm));
end;

procedure TmCDDoor.Open;
var
     SetParm: TMCI_Set_Parms;
begin
     Flag := 0;
     Flag := Flag or mci_Set_Door_Open;
     Flag := Flag or Mci_Wait;
     ReturnCode := mciSendCommand( DeviceID, mci_Set, Flag, Longint(@SetParm));
end;

procedure TmCDDoor.Close;
var
     SetParm: TMCI_Set_Parms;
begin
     Flag := 0;
     Flag := Flag or mci_Set_Door_Closed;
     Flag := Flag or Mci_Wait;
     ReturnCode := mciSendCommand( DeviceID, mci_Set, Flag, Longint(@SetParm));
end;



procedure Register;
begin
  RegisterComponents('Mcaselli', [TmCDDoor]);
end;

end.
